-- 英雄殿
checkRequire("Lua_HeroAssemblyPanel");
checkRequire("Lua_HeroAssemblyItem");
checkRequire("Lua_HeroReshapePanel");
checkRequire("Lua_HeroFastUpStarPanel");
checkRequire("Lua_HeroDecomposePanel");
-- checkRequire("Lua_HeroReplacementPanel");
Lua_HeroAssemblyWindow = class("Lua_HeroAssemblyWindow", Lua_Window);

function Lua_HeroAssemblyWindow:ctor()
	self:superCall("ctor");
	self.layer = MainWinDefine.NORMAL_WINDOW_LAYER;
	self.windowName = "Lua_HeroAssemblyWindow";
	self.skinName = "HeroAssemblyWindow_skin";
	self.isFullSizeWin = true;
	self.isSingleShowWin = true;
	self.winBgPosY = 255;
	self.showWinBg = true;
	self.winBgPath = "/maps/uiscene/ui_yxsd_bj_002.jpg";
   	self:addPreLoadRes(self.winBgPath, Lua_LoadFileType.IMG);
	self:addPreLoadRes("/images/hero_assembly/ui_yxsd_widget_02.png", Lua_LoadFileType.IMG);
end

function Lua_HeroAssemblyWindow:buildShowItem()
	self:superCall("buildShowItem");
	self.winBg:setEnable(false);
	self:addLuaEvent("UP_START_HERO_MODEL", self, self.showModel);
	self:addLuaEvent("SELECT_HEROASSEMBLY_BTN", self, self.updateBtnSelect);
	self:addLuaEvent("SELECT_HEROASSEMBLY_STAR", self, self.updateHeroSelect);
	self:addLuaEvent("UPDATE_HEROASSEMBLY_STATE", self, self.updateShowBtnInfo);--功能状态更新
	
	self:addLuaEvent("DELETE_HERO_ITEM", self, self.updateShowBtnInfo);--流放（英雄删除）
	self:addLuaEvent("UPDATE_REBUILD_INFO", self, self.updateShowBtnInfo);--回退
	self:addLuaEvent("UPDATE_INTELLIGENT_STATE", self, self.updateShowBtnInfo);--快捷升星
	

	self.btnInfo = Array();
	self.btnInfo:add({ index = 1, panel = Lua_HeroReshapePanel, iconStr = "ui_yxsd_button_001" }); -- 回退
	self.btnInfo:add({ index = 2, panel = Lua_HeroFastUpStarPanel, iconStr = "ui_yxsd_button_002"}); -- 升星
	self.btnInfo:add({ index = 3, panel = Lua_HeroDecomposePanel, iconStr = "ui_yxsd_button_003" }); -- 流放
	-- self.btnInfo:add({ index = 4, panel = Lua_HeroReplacementPanel, iconStr = "ui_yxsd_button_003" });

	self.btnList = Lua_DragList.new(self.content, 360, 108, Lua_AxisDefine.Horizontal);
	self.btnList:setRectAnchor(7);
	self.btnList:setLocation(178, 55, 0);
	self.btnList.canDrag = false;
	self.btnList:setListCell(Lua_HeroAssemblyBtnItem, 120, 108, 1);

	self:createBackBtn();
end

function Lua_HeroAssemblyWindow:onBackBtnClick()
	DataCenter.funcPathUtil:gotoFunction(1098, true);
end

function Lua_HeroAssemblyWindow:showWin(param)
	self:superCall("showWin", param);

	local index;
	if type(param) == "number" then
		index = param;
	elseif type(param) == "table" then
		index = param.main_id;
	end

	index = index == nil and 2 or index;
	self:updateShowBtnInfo();
	self.btnList:setSelectClick(index);
	self.btnList:setSelected(index);
end

function Lua_HeroAssemblyWindow:updateHeroSelect(data)
	if self.curPanel == nil then
		return;
	end
	self.data = data;
	self.curPanel:updateHeroSelect(data);
	self:showModel(data);
end

function Lua_HeroAssemblyWindow:showModel(heroVo)
	if Lua_WindowUtil.isWindowShowing("Lua_HeroShowAtlasAttributeWindow") then
		return
	end
	if DataCenter.heroUpStarData.bUpStarHeroVo == false then
		DataCenter.heroUpStarData.bUpStarHeroVo = heroVo;
		return
	end

	if heroVo == nil then
		if self.modelScenePanel ~= nil then
			self.modelScenePanel:setModelEnable(false);
		end
		return
	end
	
	if self.showHeroId == heroVo.id then
		if self.modelScenePanel ~= nil then
			self.modelScenePanel:setModelEnable(true);
		end
		return
	end
	self.showHeroId = heroVo.id;

	if self.modelScenePanel == nil then
		self.modelScenePanel = Lua_ModelScenePanel.new();
		self.modelScenePanel:setParent(self.content);
		self.modelScenePanel:setRotBgDimensions(720, 720);
		self.modelScenePanel:setRotBgPos(0, 130);
	end

	self.modelScenePanel:addActIdEffs(Lua_ThingDefine.UIWAIT, heroVo.poseActEffs);
	self.modelScenePanel:addActIdEffs(Lua_ThingDefine.UISHOW, heroVo.showActEffs);
	self.modelScenePanel:showModelScene(Lua_HeroAssemblyUtil.sceneId, heroVo.uiModelUrl, heroVo.uiModelAvatarName, heroVo.uiModelCamController)
	self.modelScenePanel:setModelAct(heroVo.uiShowAct, Lua_ThingDefine.UIWAIT, true);
	self.modelScenePanel:setModelDir(heroVo.uiModelDir);
end

function Lua_HeroAssemblyWindow:updateShowBtnInfo()
	self.btnList:setArrayData(self.btnInfo);
	if  self.selectedIdx == 1 then
		if DataCenter.heroAssemblyData.rollbackState == 0 then
			self.btnList:setSelectClick(2);
			self.btnList:setSelected(2);
			OperateAlert.showLangValue(126406);
		else
			self:showModel(nil);
		end
	end
end

function Lua_HeroAssemblyWindow:updateBtnSelect(data)
	if self.selectedIdx == data.index then
		return;
	end
	self.selectedIdx = data.index
	self:showModel(nil);
	if self.curPanel ~= nil then
		self.curPanel:dispose();
		self.curPanel = nil;
	end
	
	self.winBg:setEnable(data.index == 3);
	self.curPanel = data.panel.new(self.content);
	self.curPanel:setRectAnchor(9);
	self.curPanel:updateShowInfo();

	if self.tweenName ~= nil then
		DataCenter.winTweenManager:removeWinTween(self.tweenName);
	end
	self.tweenName = DataCenter.winTweenManager:createWinTween(self.curPanel.content.name, self.curPanel.content.transform);
end

function Lua_HeroAssemblyWindow:resetActive(bActive)
    self:superCall("resetActive", bActive);
    self.showHeroId = nil;
    if bActive then -- 显示
        if self.data ~= nil then
            self:showModel(self.data);
        end
    else
        if self.modelScenePanel ~= nil then
            self.modelScenePanel:dispose();
            self.modelScenePanel = nil;
        end
    end
end

function Lua_HeroAssemblyWindow:dispose()
	if self.curPanel ~= nil then
		self.curPanel:dispose();
		self.curPanel = nil;
	end
	if self.btnList ~= nil then
		self.btnList:dispose();
		self.btnList = nil;
	end
	if self.btnInfo ~= nil then
		self.btnInfo:clear();
		self.btnInfo = nil;
	end
	if self.modelScenePanel ~= nil then
		self.modelScenePanel:dispose()
		self.modelScenePanel = nil
	end
	self.data = nil;
	DataCenter.winTweenManager:removeWinTween(self.tweenName);
	self:superCall("dispose");
end
















Lua_HeroAssemblyBtnItem = class("Lua_HeroAssemblyBtnItem", Lua_ListCell);
function Lua_HeroAssemblyBtnItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_HeroAssemblyBtnItem:buildShowItem()
	self:superCall("buildShowItem");

	self.selectBg = UICreate.createUIAtlasImage(self.content, "common_altas_1", "ui_common_button_001_b", 1, 0, 0, 0);
	self.btnBg = UICreate.createUIAtlasImage(self.content, nil, nil, 1, 0, 0, 0);
	self.btnLine = UICreate.createUIAtlasImage(self.content, "common_altas_1", "ui_common_line_011", -59, 0, 2, 108);
end

function Lua_HeroAssemblyBtnItem:dispose()
	if self.redPoint ~= nil then
		self.redPoint:dispose();
		self.redPoint = nil;
	end
	self:superCall("dispose");
end

function Lua_HeroAssemblyBtnItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end
	
	self:updateBtnState();
	self:updateRedDotShow();
end

function Lua_HeroAssemblyBtnItem:onSelectionChange(bSelect)
	self:superCall("onSelectionChange", bSelect);
	if bSelect then
		self.btnBg:setAltas("hero_assembly", self.data.iconStr .. "_p");
		self.selectBg:setEnable(true);
	else
		self.btnBg:setAltas("hero_assembly", self.data.iconStr .. "_n");
		self.selectBg:setEnable(false);
	end
	self.btnBg:resetSize();
end

function Lua_HeroAssemblyBtnItem:onPressClick()
	if self.data == nil then
		return;
	end

	if not self.openState then
		if self.data.index == 1 then
			OperateAlert.showLangValue(126405);
		elseif self.data.index == 4 then
			OperateAlert.showLangValue(126407);
		end
		return;
	end
	Lua_MsgUtil.callFunc("SELECT_HEROASSEMBLY_BTN", self.data);
	return true;
end

function Lua_HeroAssemblyBtnItem:updateBtnState()
	if self.data.index == 1 then
		self.openState = DataCenter.heroAssemblyData.rollbackState == 1;
	elseif self.data.index == 4 then
		self.openState = DataCenter.heroAssemblyData.replaceState == 1;
	else
		self.openState = true;
	end

	self.btnBg:setGray(not self.openState);
end

function Lua_HeroAssemblyBtnItem:updateRedDotShow()
	if self.data.index == 2 then
		local state = DataCenter.heroAssemblyUtil.isExitUpStar;
		if state == true then
			if self.redPoint == nil then
				self.redPoint = Lua_RedPointIcon.new(self.content);
				self.redPoint:setLocation(45, 35, 0);
				self.redPoint:createRedPointEff();
			end
			self.redPoint:updateRedPointShow(true);
		else
			if self.redPoint ~= nil then
				self.redPoint:updateRedPointShow(false);
			end
		end
	else
		if self.redPoint ~= nil then
			self.redPoint:updateRedPointShow(false);
		end
	end
end