--英雄殿 英雄流放 选择Item
Lua_HeroDecomposeItem = class("Lua_HeroDecomposeItem", Lua_ListCell);
function Lua_HeroDecomposeItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_HeroDecomposeItem:buildShowItem()
	self:superCall("buildShowItem");
	self.beforeSelect = false;
	self:addLuaEvent("UPDATE_HERO_DECOMPOSE_SELECT", self, self.updateSelectShow);

	self.heroItem = Lua_ItemIcon.new(self.content);
	self.heroItem:setScale(0.9,0.9);
end

function Lua_HeroDecomposeItem:dispose()
	if self.heroItem ~= nil then
		self.heroItem:dispose();
		self.heroItem = nil;
	end
	self.unique_id = nil;
	self.hvo = nil;
	self:superCall("dispose");
end

function Lua_HeroDecomposeItem:setData(data)
	self.unique_id = data;
	self.hvo = DataCenter.heroData:getItemByUniqueId(data);
	if self.hvo == nil then
		return
	end

	self.heroItem:setData(self.hvo);

	self:updateSelectShow();
end

function Lua_HeroDecomposeItem:onPressClick()
	if self.hvo == nil then
        return;
    end

    if self.bSelect then--已选中，点击取消
        self:onSureBtnClick();
        return
    end

    if self.hvo.is_resonance == true then--同调器中
        self:showRemoveResonanceTips();
        return;
    end

    if self.hvo.isUpLineup and DataCenter.heroAssemblyData.removeLineupStateDic[self.unique_id] == nil then --是否显示下阵tips
        self:showHeroLineupTips();
        return;
    end

    if self.hvo.lock_state == true then--上锁tips
        self:showHeroUnlockTips();
        return;
    end

	self:onSelectItem()
end

function Lua_HeroDecomposeItem:onSelectItem()
    if DataCenter.heroAssemblyData.decomposeCount < 15 then
		if self.hvo ~= nil and self.hvo.bcore then
			local tipsData = { des = LanUtil.getValue(126403), btnType = 1, owner = self, sureFun = self.onSureBtnClick };
			Lua_WindowUtil.openWin("Lua_TipsWindow", nil, tipsData);
			return;
		end
		self:onSureBtnClick();
	else
		OperateAlert.showLangValue(126402);
	end
end

--英雄下阵
function Lua_HeroDecomposeItem:showHeroLineupTips()
    local tipData = { h = 443, font_size = 26, des = LanUtil.formateStr(126221, self.hvo.upLineupName), posY = 44,
        btnType = 1, owner = self, sureFun = self.onHeroLineup };
    Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipData);
end

--英雄下阵
function Lua_HeroDecomposeItem:onHeroLineup()
    local bDownLineup;
    local showName;
    bDownLineup, showName = DataCenter.heroAssemblyData:checkLineupNumState(self.unique_id);
    if bDownLineup then--是否可以下阵
        OperateAlert.showLangValue(126222);
        DataCenter.heroAssemblyData.removeLineupStateDic[self.unique_id] = 1;
    else
        OperateAlert.show(LanUtil.formateStr(126223, showName));
        return
    end
    
    if self.hvo.lock_state == true then--上锁tips
        self:showHeroUnlockTips();
        return;
    end

    self:onSelectItem();
end

--英雄解锁tips
function Lua_HeroDecomposeItem:showHeroUnlockTips()
    local tipData = { h = 443, font_size = 26, des = LanUtil.getValue(126219), posY = 44,
        btnType = 1, owner = self, sureFun = self.sendUnlock };
    Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipData);
end

--英雄解锁
function Lua_HeroDecomposeItem:sendUnlock()
    Lua_ProxyManager.getProxy("Lua_HeroProxy"):sHeroLock(self.unique_id, 0);
    if not self.hvo.bcore then
        OperateAlert.showLangValue(126220);
    end
    self:onSelectItem();
end

--同调器tips
function Lua_HeroDecomposeItem:showRemoveResonanceTips()
    local tipData = {
        h = 443, font_size = 26, des = LanUtil.getValue(126919), posY = 44,
        btnType = 1, owner = self, sureFun = self.sendDemount
    };
    Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipData);
end

--从同调器中卸下
function Lua_HeroDecomposeItem:sendDemount()
    local grid_id = DataCenter.lifeTreeData:getGridIdByUid(self.unique_id);
    if grid_id == 0 then
        return;
    end
    Lua_ProxyManager.getProxy("Lua_LifeTreeProxy"):sDemountHero(grid_id);
end

function Lua_HeroDecomposeItem:onSureBtnClick()
	DataCenter.heroAssemblyData:setDecomposeUidListBySelect(self.unique_id);
	Lua_MsgUtil.callFunc("UPDATE_HERO_DECOMPOSE_SELECT");
end

function Lua_HeroDecomposeItem:updateSelectShow()
    self.bSelect = DataCenter.heroAssemblyData.decomposeUidList[self.unique_id] == 1;
    if self.bSelect then
        self.heroItem:setDrawMask(true);
        self.heroItem:setMask(false);
        self.heroItem:setLock(false);
    else
        self.heroItem:setDrawMask(false);
        local list = DataCenter.heroAssemblyData.removeLineupStateDic;
        if self.hvo.lock_state == true or self.hvo.is_resonance or (self.hvo.isUpLineup == true and list[self.unique_id] ~= 1) then
            self.heroItem:setLock(true);
            self.heroItem:setMask(true);
        else
            self.heroItem:setMask(false);
            self.heroItem:setLock(false);
        end
    end
end