--英雄殿 英雄流放panel
checkRequire("Lua_HeroDecomposeItem");
Lua_HeroDecomposePanel = class("Lua_HeroDecomposePanel", Lua_HeroAssemblyPanel);
function Lua_HeroDecomposePanel:ctor(p)
	self:superCall("ctor", p, "HeroDecomposePanel_skin");
end

function Lua_HeroDecomposePanel:buildShowItem()
	self:superCall("buildShowItem");
	self:addLuaEvent("DELETE_HERO_ITEM", self, self.onDecomposeEnd);
	self:addLuaEvent("UPDATE_ONE_HERO_INFO", self, self.updateHeroInfo);-- 英雄 同调器状态改变 数据更新
	self:addLuaEvent("UPDATE_HERO_DECOMPOSE_SELECT", self, self.updateSelectShow);

	self.talkTxt:setLangValue(126438);
	
	self.itemList = Lua_DragList.new(self.content, 640, 280, Lua_AxisDefine.Vertical);
	self.itemList:setRectAnchor(7);
	self.itemList:setLocation(0, 380, 0);
	self.itemList:setListCell(Lua_HeroDecomposeItem, 112, 112, 5);
	self.itemList:setCellSpacing(20, 15);
	self.itemList.tweenId = 2003;
	self.itemList.delayTween = true;

	self.showExpList = Lua_DragList.new(self.showRewardObj, 229, 275, Lua_AxisDefine.Vertical);
	self.showExpList:setLocation(220.5, 375, 0);
	self.showExpList:setListCell(Lua_HeroDecomposeExpItem, 112, 112, 2);
	self.showExpList:setCellSpacing(5, 5);

	self.campSiftPanel = Lua_CampSiftPanel.new(self.content);
    self.campSiftPanel:setRectAnchor(7);
    self.campSiftPanel:setLocation(-32, 150, 0);
    self.campSiftPanel:setSiftItem(82);
    self.campSiftPanel:setArrayData(DataCenter.heroUtil.siftAllInfo);
    self.campSiftPanel:setCallBack(self, self.onCampSelected);
    self.campSiftPanel:setSelected(Lua_HeroUtil.All_TYPE, true);
    
	-- self.showRewardObj:SetActive(false);
	self.numText.text = LanUtil.formateStr(126423, "0", DataCenter.heroUtil.cancle_number);

	self.autoCheckBox.selected = DataCenter.heroAssemblyData.cancellingState == 1;
	self.autoCheckBox:addBoxChange(self, self.onAutoCheckChange);

	self.btnSelect:addClickFuntion(self, self.onFastSelectClick);
	self.btnClean:addClickFuntion(self, self.onCleanClick);
	self.btnDecompose:addClickFuntion(self, self.onDecomposeClick);
	self.btnHelp:addClickFuntion(self, self.onHelpClick);
	self.shopBtn:addClickFuntion(self, self.onShopBtnClick); -- 商店
end

function Lua_HeroDecomposePanel:dispose()
	if self.itemList ~= nil then
		self.itemList:dispose();
		self.itemList = nil;
	end
	if self.showExpList ~= nil then
		self.showExpList:dispose();
		self.showExpList = nil;
	end

	if self.campSiftPanel ~= nil then
		self.campSiftPanel:dispose();
		self.campSiftPanel = nil;
	end
	if self.arr ~= nil then
		self.arr:clear();
		self.arr = nil;
	end
	TweenUtil.getInstance():stop(self.showRewardObj);
	TweenUtil.getInstance():stop(self.raccoonImg.mainContent);
	DataCenter.heroAssemblyData:dispose();
	self:superCall("dispose");
end

function Lua_HeroDecomposePanel:onCampSelected(campType, isUpdate)
	if self.selectedCampType == campType and isUpdate ~= true then
		return;
	end
	self.selectedCampType = campType;
	self:updateHeroInfo();
end

function Lua_HeroDecomposePanel:updateHeroInfo(uid)
	self.arr = DataCenter.heroAssemblyData:sortDecomposeHeroArr(self.selectedCampType);
	self.itemList:setArrayData(self.arr);
	if uid == nil then--有影响状态更新不在 moveToIndex
		self.itemList:moveToIndex(1, true);
	end
	self:showNone(self.arr:getSize() <= 0);
end

function Lua_HeroDecomposePanel:updateSelectShow()
	self.showExpList:setArrayData(DataCenter.heroAssemblyData.getDecomposeExpArr);
	self.numText.text = LanUtil.formateStr(126423, DataCenter.heroAssemblyData.decomposeCount, DataCenter.heroUtil.cancle_number);
	self.btnClean:setEnable(DataCenter.heroAssemblyData.decomposeCount > 0);
	-- self.showRewardObj:SetActive(DataCenter.heroAssemblyData.decomposeCount > 0);

	self:showDecomposeTweenPos(DataCenter.heroAssemblyData.decomposeCount > 0);
end

function Lua_HeroDecomposePanel:onFastSelectClick()
	DataCenter.heroAssemblyData:fastDecomposeSelect(self.arr);
	Lua_MsgUtil.callFunc("UPDATE_HERO_DECOMPOSE_SELECT");
end

function Lua_HeroDecomposePanel:onCleanClick()
	DataCenter.heroAssemblyData:initDecomposeUidList();
	Lua_MsgUtil.callFunc("UPDATE_HERO_DECOMPOSE_SELECT");
end

function Lua_HeroDecomposePanel:onDecomposeClick()
	if DataCenter.heroAssemblyData.isExitHeroSixStar then
		local tipsData = { des = LanUtil.getValue(126404), btnType = 1, owner = self, sureFun = self.onSureDecompose };
		Lua_WindowUtil.openWin("Lua_TipsWindow", nil, tipsData);
	else
		self:onSureDecompose();
	end
end

function Lua_HeroDecomposePanel:onSureDecompose()
	local list = DataCenter.heroAssemblyData.decomposeUidList;
	if list ~= nil and table.length(list) > 0 then
		Lua_ProxyManager.getProxy("Lua_HeroAssemblyProxy"):sHeroDecompose(list);
	else
		OperateAlert.showLangValue(126437);
	end
end

function Lua_HeroDecomposePanel:onAutoCheckChange(val)
	local state = val and 1 or 0;
	Lua_ProxyManager.getProxy("Lua_HeroAssemblyProxy"):sSetAutoDecompose(state);
end

function Lua_HeroDecomposePanel:onHelpClick()
	local tipsData = { des = LanUtil.getValue(126420), posX = 215, posY = -175 };
	Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
end

function Lua_HeroDecomposePanel:onDecomposeEnd()
	OperateAlert.showLangValue(126430);
	DataCenter.heroAssemblyData:initDecomposeUidList();
	self:updateSelectShow();
	self:onCampSelected(self.selectedCampType, true);
end

-- 商店
function Lua_HeroDecomposePanel:onShopBtnClick()
	DataCenter.funcPathUtil:gotoFunction(1118);
end

-- 动画设置
function Lua_HeroDecomposePanel:showDecomposeTweenPos(bool)
	if self.bool == bool then
		return
	end
	
	self.bool = bool;
	local imgPox;--图片位置
	local objPox;--对象位置
	local attr_offect = 0;--回弹系数
	if bool then--向左
		imgPox = -137;
		objPox = 0;
		self.showTipObj:SetActive(false);
	else--向右
		imgPox = -48;
		objPox = 300;
	end
	
	TweenUtil.getInstance():stop(self.raccoonImg.mainContent);
	TweenUtil.getInstance():addTweenTargetPos(self.raccoonImg.mainContent, 0.2, 0, imgPox, 138, 0, 
        self, self.onTweenImegPos, attr_offect, false, 0);

    TweenUtil.getInstance():stop(self.showRewardObj);
    TweenUtil.getInstance():addTweenTargetPos(self.showRewardObj, 0.2, 0, objPox, -720, 0, 
        nil, nil, attr_offect, false, 0);
end

function Lua_HeroDecomposePanel:onTweenImegPos()
	TweenUtil.getInstance():stop(self.raccoonImg.mainContent);
	self.showTipObj:SetActive(not self.bool);
end

















Lua_HeroDecomposeExpItem = class("Lua_HeroDecomposeExpItem", Lua_ListCell);
function Lua_HeroDecomposeExpItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_HeroDecomposeExpItem:buildShowItem()
	self:superCall("buildShowItem");

	self.expItem = Lua_ItemIcon.new(self.content);
	self.expItem:setScale(0.9,0.9);
end

function Lua_HeroDecomposeExpItem:dispose()
	if self.expItem ~= nil then
		self.expItem:dispose();
		self.expItem = nil;
	end
	self.data = nil;
	self:superCall("dispose");
end

function Lua_HeroDecomposeExpItem:setData(data)
	self.data = Lua_ToolVo.createToolVo(data.id, data.num)
	self.expItem:setData(self.data);
end

function Lua_HeroDecomposeExpItem:onPressClick()
	if self.data == nil then
		return;
	end
	DataCenter.packUtil:showItemInfo(self.data);
end