--英雄神殿 英雄置换
checkRequire("Lua_HeroAssemblyCostItem");
Lua_HeroReplacementPanel = class("Lua_HeroReplacementPanel", Lua_HeroAssemblyPanel);

function Lua_HeroReplacementPanel:ctor(p)
	self:superCall("ctor", p, "HeroReplacementPanel_skin");
end

function Lua_HeroReplacementPanel:buildShowItem()
	self:superCall("buildShowItem");

	self:addLuaEvent("UPDATE_ITEM_HEROREPLACEMENT_SELECT", self, self.updateCostSelect);
	self:addLuaEvent("UPDATE_REPLACEMENT_STATE", self, self.onReplacementEnd);
	
	self.isFristEnter = true;

	self.costItem = Lua_HeroAssemblyCostItem.new(self.content);
	self.costItem:setLocation(-300, 500, 0);
	self.costItem:setData(DataCenter.heroAssemblyData.getReplacementCostInfo[1]);

	self.itemList = Lua_DragList.new(self.content, 625, 280, Lua_AxisDefine.Vertical);
	self.itemList:setListCell(Lua_HeroAssemblyItem, 125, 130, 5);
	self.itemList:setLocation(0, -180, 0);

	self.campSiftPanel = Lua_CampSiftPanel.new(self.content);
    self.campSiftPanel:setLocation(-32, -375, 0);
    self.campSiftPanel:setSiftItem(82);
    self.campSiftPanel:setArrayData(DataCenter.heroUtil.siftAllInfo);
    self.campSiftPanel:setCallBack(self, self.onCampSelected);
    self.campSiftPanel:setSelected(Lua_HeroUtil.All_TYPE, true);
   
	self.heroCostBg:addClickFuntion(self, self.onAddHeroClick);
	self.replacementBtn:addClickFuntion(self, self.onReplacementClick);
	self.btnHelp:addClickFuntion(self, self.onHelpClick);
end

function Lua_HeroReplacementPanel:dispose()
	TweenUtil.getInstance():stop(self.showTipObj);
	if self.itemList ~= nil then
		self.itemList:dispose();
		self.itemList = nil;
	end
	if self.campSiftPanel ~= nil then
		self.campSiftPanel:dispose();
		self.campSiftPanel = nil;
	end
	if self.costItem ~= nil then
		self.costItem:dispose();
		self.costItem = nil;
	end
	if self.modeEffImg ~= nil then
		self.modeEffImg:dispose();
		self.modeEffImg = nil;
	end 
	if self.replacementModelImg ~= nil then
		self.replacementModelImg:dispose();
		self.replacementModelImg = nil;
	end
	DataCenter.heroAssemblyData:dispose();
	self:superCall("dispose");
end

function Lua_HeroReplacementPanel:onScreenResize(adaptHeight)
	self:superCall("onScreenResize", adaptHeight);
end

function Lua_HeroReplacementPanel:onCampSelected(campType, isUpdate)
	if self.selectedCampType == campType and isUpdate ~= true then
		return;
	end
	self.selectedCampType = campType;

	local arr = DataCenter.heroAssemblyData:getReplacementHeroArr(campType);
	self.itemList:setArrayData(arr);
	self.itemList:moveToIndex(1, true);
	self.tipTxt:setEnable(arr:getSize() <= 0);
end

function Lua_HeroReplacementPanel:updateHeroSelect(data)
	if self.isFristEnter then
		self.isFristEnter = false;
		TweenUtil.getInstance():addTweenTargetPos(self.showTipObj, 0.8, 0, -520, 0, 0, 0, false);
	end
	self.showHeroObj:SetActive(true);

	self.data = data;
	self:showSelectModel(data);

	DataCenter.heroAssemblyData:clearReplacementInfo();

	self:updateCostSelect();
end

function Lua_HeroReplacementPanel:updateCostSelect()
	self.heroCostNumTxt.text = DataCenter.heroAssemblyData.selectReplacementCostNum .. "/" .. DataCenter.heroAssemblyData.getReplacementMaxNum;
	self:showReplacementModel(DataCenter.heroAssemblyData.isMaxLimit);

	if DataCenter.heroAssemblyData.selectReplacementCostNum > 0 then
		local costHeroVo = DataCenter.heroAssemblyData.replacementCostHeroVo;
		self.heroCostBg:setAltas(tostring(costHeroVo.atlas), tostring(costHeroVo.sprite));
	else
		self.heroCostBg:setAltas("iconantlas1", "common_icon_bg_01");
	end
	
	local isShow = DataCenter.heroAssemblyData.selectReplacementCostNum < DataCenter.heroAssemblyData.getReplacementMaxNum;
	self.heroCostAdd:setEnable(isShow);

	self.replacementBtn.label = LanUtil.formateStr(126417, tostring(DataCenter.heroAssemblyData.getReplacementCostInfo[2]));
end

function Lua_HeroReplacementPanel:showSelectModel(heroVo)
	if heroVo ~= nil then
		if self.modeEffImg == nil then
			self.modeEffImg = UICreate.createModelEffImg(self.content, nil, nil, -200, 250, 300, 300);
		end
		self.modeEffImg:setUrl(heroVo.modelUrl, heroVo.modelSrc)
		self.modeEffImg:setCamField(1, 1, 100, true);
		self.modeEffImg:setCamPos(0, 1, -10);
		self.modeEffImg:setModelEffDir(90);
		self.modeEffImg.canRot = true;
		self.modeEffImg:setEnable(true);
	else
		if self.modeEffImg ~= nil then
			self.modeEffImg:setEnable(false);
		end
	end
end

function Lua_HeroReplacementPanel:showReplacementModel(val)
	if val then
		if self.replacementModelImg == nil then
			self.replacementModelImg = UICreate.createModelEffImg(self.content, nil, nil, 200, 250, 300, 300);
		end

		local heroVo = DataCenter.heroAssemblyData.replacementCostHeroVo;
		self.replacementModelImg:setUrl(heroVo.modelUrl, heroVo.modelSrc)
		self.replacementModelImg:setCamField(1, 1, 100, true);
		self.replacementModelImg:setCamPos(0, 1, -10);
		self.replacementModelImg:setModelEffDir(90);
		self.replacementModelImg.canRot = true;
		self.replacementModelImg:setEnable(true);
	else
		if self.replacementModelImg ~= nil then
			self.replacementModelImg:setEnable(false);
		end
	end
end

function Lua_HeroReplacementPanel:onAddHeroClick(go)
	if DataCenter.heroAssemblyData.selectHeroVo ~= nil then
		Lua_WindowUtil.openWin("Lua_HeroReplacementSelectWindow", Lua_WinParam.ACTION_OPEN, nil);
	end
end

function Lua_HeroReplacementPanel:onReplacementClick()
	if DataCenter.heroAssemblyData.selectHeroVo ~= nil then
		if not DataCenter.heroAssemblyData.isMaxLimit then
			OperateAlert.showLangValue(126410);
			return;
		end
		Lua_WindowUtil.openWin("Lua_HeroReplacementResultWindow", Lua_WinParam.ACTION_OPEN, nil);
	end
end

function Lua_HeroReplacementPanel:onHelpClick()
	local tipsData = { des = LanUtil.getValue(126421), posX = 80, posY = 462 };
	Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
end

function Lua_HeroReplacementPanel:onReplacementEnd()
	OperateAlert.showLangValue(126431);
	DataCenter.heroAssemblyData.selectHeroVo = nil;
	self.costItem:setData(DataCenter.heroAssemblyData.getReplacementCostInfo[1])
	self.replacementBtn.label = LanUtil.formateStr(126418, tostring(DataCenter.heroAssemblyData.getReplacementCostInfo[2]));
	self:showSelectModel(nil);
	self:showReplacementModel(false);
	self.showHeroObj:SetActive(false);
	self:onCampSelected(self.selectedCampType, true);
end