Lua_HeroReplacementResultWindow = class("Lua_HeroReplacementResultWindow", Lua_Window);
function Lua_HeroReplacementResultWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_HeroReplacementResultWindow";
	self.skinName = "HeroReplacementResultWindow_skin";
end

function Lua_HeroReplacementResultWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.itemList = Lua_DragList.new(self.content, 500, 400, Lua_AxisDefine.Vertical);
	self.itemList:setLocation(0, 230, 0);
	self.itemList:setListCell(Lua_HeroReplacementResultItem, 110, 110, 5);
	self.itemList:setArrayData(DataCenter.heroAssemblyData.rebuildCostArr);

	self.limitTime = DataCenter.heroUtil.rebuild_time;
	self.isAllow = false;
	self:onCountDown();
	self:addTimer("onCountDown", 1, self, self.onCountDown);

	self.btn_cancel:addClickFuntion(self, self.onCancelClick);
	self.btn_sure:addClickFuntion(self, self.onSureClick);
end

function Lua_HeroReplacementResultWindow:dispose()
	if self.itemList ~= nil then
		self.itemList:dispose();
		self.itemList = nil;
	end
	self.removeTimer(self, self.onCountDown);
	self:superCall("dispose");
end

function Lua_HeroReplacementResultWindow:onCountDown()
	self.limitTime = self.limitTime - 1;
	if self.limitTime <= 0 then
		self.limitTime = 0;
		self.isAllow = true;
		self.btn_sure:setLangValue(11);
		self.removeTimer(self, self.onCountDown);
	else
		self.btn_sure.label = LanUtil.formateStr(126424, tostring(self.limitTime));
	end
end

function Lua_HeroReplacementResultWindow:onCancelClick()
	self:hide();
end

function Lua_HeroReplacementResultWindow:onSureClick()
	if self.isAllow then
		Lua_ProxyManager.getProxy("Lua_HeroAssemblyProxy"):sHeroReplacement();
		self:hide();
	end
end

















Lua_HeroReplacementResultItem = class("Lua_HeroReplacementResultItem", Lua_ListCell);
function Lua_HeroReplacementResultItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_HeroReplacementResultItem:buildShowItem()
	self:superCall("buildShowItem");

	self.heroItem = Lua_ItemIcon.new(self.content);
	self.heroItem:setScale(0.9, 0.9, 0.9);
	self.heroItem:setLocation(0, 10, 0);
	self.heroItem:setCanClick(false);
end

function Lua_HeroReplacementResultItem:dispose()
	if self.heroItem ~= nil then
		self.heroItem:dispose();
		self.heroItem = nil;
	end
	self.data = nil;
	self:superCall("dispose");
end

function Lua_HeroReplacementResultItem:setData(data)
	if data == nil then
		return;
	end
	self.data = data;
	self.heroItem:setData(data);
end