Lua_HeroReplacementSelectWindow = class("Lua_HeroReplacementSelectWindow", Lua_Window);
function Lua_HeroReplacementSelectWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_HeroReplacementSelectWindow";
	self.skinName = "HeroReplacementSelectWindow_skin";
end

function Lua_HeroReplacementSelectWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.itemList = Lua_DragList.new(self.content, 500, 400, Lua_AxisDefine.Vertical);
	self.itemList:setLocation(0, 225, 0);
	self.itemList:setListCell(Lua_HeroReplacementSelectItem, 110, 110, 4);

	self:updateShowInfo();
end

function Lua_HeroReplacementSelectWindow:dispose()
	if self.itemList ~= nil then
		self.itemList:dispose();
		self.itemList = nil;
	end
	self:superCall("dispose");
end

function Lua_HeroReplacementSelectWindow:updateShowInfo()
	local arr = DataCenter.heroAssemblyData.getReplacementSelectArr;
	self.itemList:setArrayData(arr);
end




















Lua_HeroReplacementSelectItem = class("Lua_HeroReplacementSelectItem", Lua_ListCell);
function Lua_HeroReplacementSelectItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_HeroReplacementSelectItem:buildShowItem()
	self:superCall("buildShowItem");

	self:addLuaEvent("UPDATE_ITEM_HEROREPLACEMENT_SELECT", self, self.updateSelectShow);

	self.heroItem = Lua_ItemIcon.new(self.content);
	self.heroItem:setScale(0.9, 0.9, 0.9);
	self.heroItem:setLocation(0, 10, 0);
	self.heroItem:setCanClick(false);

	self.beforeSelect = false;
end

function Lua_HeroReplacementSelectItem:dispose()
	if self.heroItem ~= nil then
		self.heroItem:dispose();
		self.heroItem = nil;
	end
	self.data = nil;
	self:superCall("dispose");
end

function Lua_HeroReplacementSelectItem:setData(data)
	if data == nil then
		return;
	end
	self.data = data;
	self.heroItem:setData(data);
	self:updateSelectShow();
end

function Lua_HeroReplacementSelectItem:onPressClick()
	if self.data == nil then
		return;
	end

	if DataCenter.heroAssemblyData.selectReplacementCostNum ~= 0 and DataCenter.heroAssemblyData.replacementCostHeroVo.id ~= self.data.id then
		OperateAlert.showLangValue(126408);
		return;
	elseif not self.beforeSelect and DataCenter.heroAssemblyData.isMaxLimit then
		OperateAlert.showLangValue(126409);
		return;
	end

	DataCenter.heroAssemblyData:selectReplacementCost(self.data.unique_id);
	DataCenter.heroAssemblyData.replacementCostHeroVo = self.data;
	Lua_MsgUtil.callFunc("UPDATE_ITEM_HEROREPLACEMENT_SELECT");
end

function Lua_HeroReplacementSelectItem:updateSelectShow()
	local select = DataCenter.heroAssemblyData.replacementSelectList[self.data.unique_id] == 1;
	if sselect ~= self.beforeSelect then
		self.beforeSelect = select;

		if select then
			if self.selectMaskBg == nil then
				self.selectMaskBg = UICreate.createUIAtlasImage(self.content, "common_altas_1", "ui_common_window_014", 0, 10, 0, 0);
			end
			self.selectMaskBg:setEnable(true);
		else
			if self.selectMaskBg ~= nil then
				self.selectMaskBg:setEnable(false);
			end
		end
	end
end