--英雄神殿 英雄回退
Lua_HeroReshapePanel = class("Lua_HeroReshapePanel", Lua_HeroAssemblyPanel);
function Lua_HeroReshapePanel:ctor(p)
	self:superCall("ctor", p, "HeroReshapePanel_skin");
end

function Lua_HeroReshapePanel:buildShowItem()
	self:superCall("buildShowItem");
	self:addLuaEvent("UPDATE_REBUILD_INFO", self, self.onReshapeEnd);--回退
	self:addLuaEvent("UPDATE_ONE_HERO_INFO", self, self.updateHeroInfo);-- 英雄 同调器状态改变 数据更新

	self.talkTxt:setLangValue(126416);
	self.showHeroObj:SetActive(false);
	self.btnReshape:setEnable(false);

	self.itemList = Lua_DragList.new(self.content, 640, 280, Lua_AxisDefine.Vertical);
	self.itemList:setRectAnchor(7);
	self.itemList:setLocation(0, 380, 0);
	self.itemList:setListCell(Lua_HeroReshapeItem, 112, 112, 5);
	self.itemList:setCellSpacing(20, 15);
	self.itemList.tweenId = 2003;
	self.itemList.delayTween = true;

    self.campSiftPanel = Lua_CampSiftPanel.new(self.content);
    self.campSiftPanel:setRectAnchor(7);
    self.campSiftPanel:setLocation(-32, 150, 0);
    self.campSiftPanel:setSiftItem(82);
    self.campSiftPanel:setArrayData(DataCenter.heroUtil.siftAllInfo);
    self.campSiftPanel:setCallBack(self, self.onCampSelected);

	self.btnHelp:addClickFuntion(self, self.onHelpClick);
	self.btnReshape:addClickFuntion(self, self.onReshapeClick);
end

function Lua_HeroReshapePanel:dispose()
	if self.itemList ~= nil then
		self.itemList:dispose();
		self.itemList = nil;
	end
	if self.campSiftPanel ~= nil then
		self.campSiftPanel:dispose();
		self.campSiftPanel = nil;
	end
	DataCenter.heroAssemblyData:dispose();
	DataCenter.heroAssemblyUtil.reshapeSelectHeroUid = nil;
	self:superCall("dispose");
end

function Lua_HeroReshapePanel:updateShowInfo()
	self.campSiftPanel:setSelected(Lua_HeroUtil.All_TYPE, true);
end

function Lua_HeroReshapePanel:onCampSelected(campType, isUpdate)
	if self.selectedCampType == campType and isUpdate ~= true then
		return;
	end
	self.selectedCampType = campType;

	self:updateHeroInfo();
end

function Lua_HeroReshapePanel:updateHeroInfo(uid)
	local arr = DataCenter.heroAssemblyUtil:getReshapeHeroArr(self.selectedCampType);
	self.itemList:setArrayData(arr);
	if uid == nil then--有影响状态更新不在 moveToIndex
		self.itemList:moveToIndex(1, true);
	end

	self:showNone(arr:getSize() <= 0);
end

function Lua_HeroReshapePanel:updateHeroSelect(data)
	if self.data == data then
		return;
	end
	self.data = data;

	if data == nil then
		self.raccoonImg:setEnable(true);
		self.showTipObj:SetActive(true);
		self.showHeroObj:SetActive(false);
		self.btnReshape:setEnable(false);
		self:showStar(0);
		self.itemList.customParam = nil;
	else
		self.raccoonImg:setEnable(false);
		self.showTipObj:SetActive(false);
		self.showHeroObj:SetActive(true);
		self.btnReshape:setEnable(true);
		self.typeIcon:setAltas("common_altas_3", tostring(data.campSprite));
		self.nameText.text = data.name;
		self.levelTxt.text = LanUtil.formateStr(126428, data.level);
		self:showStar(data.star);
		self.itemList.customParam = data.unique_id;
	end
end

function Lua_HeroReshapePanel:onReshapeClick(go)
	if self.data == nil then return end;
	if not DataCenter.heroData:isBagEnough(1) then
		OperateAlert.showLangValue(126433);
		return
	end
	Lua_WindowUtil.openWin("Lua_HeroReshapeWindow", Lua_WinParam.ACTION_OPEN, self.data);
end

function Lua_HeroReshapePanel:onHelpClick()
	local tipsData = { des = LanUtil.getValue(126422), posX = 215, posY = -175 };
	Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
end

function Lua_HeroReshapePanel:onReshapeEnd()
	DataCenter.heroAssemblyUtil.reshapeSelectHeroUid = nil;
	self:updateHeroSelect(nil);
	self:onCampSelected(self.selectedCampType, true);
	OperateAlert.showLangValue(126429);
end




















Lua_HeroReshapeItem = class("Lua_HeroReshapeItem", Lua_ListCell);
function Lua_HeroReshapeItem:ctor(p, skin)
	self:superCall("ctor", p, skin);
end

function Lua_HeroReshapeItem:buildShowItem()
	self:superCall("buildShowItem");
	self:addLuaEvent("SELECT_HEROASSEMBLY_STAR", self, self.updateSelectShow);

	self.heroItem = Lua_ItemIcon.new(self.content);
	self.heroItem:setScale(0.9, 0.9);
end

function Lua_HeroReshapeItem:dispose()
	if self.heroItem ~= nil then
		self.heroItem:dispose();
		self.heroItem = nil;
	end
	self.data = nil;
	self:superCall("dispose");
end

function Lua_HeroReshapeItem:setData(data)
	self.hvo = data;
	if data == nil then
		return;
	end
	self.unique_id = data.unique_id;
	self.heroItem:setData(data);
	self:updateSelectShow();
end

function Lua_HeroReshapeItem:onPressClick()
	if self.hvo == nil then
		return;
	end

	if self.bSelect then--已选中
        return
    end

    if self.hvo.is_resonance == true then--同调器中
        self:showRemoveResonanceTips();
        return;
    end

    if self.hvo.isUpLineup and DataCenter.heroAssemblyData.removeLineupStateDic[self.unique_id] == nil then --是否显示下阵tips
        self:showHeroLineupTips();
        return;
    end

    if self.hvo.lock_state == true then--上锁tips
        self:showHeroUnlockTips();
        return;
    end

    self:onSelectItem();
end

--英雄解锁tips
function Lua_HeroReshapeItem:showHeroUnlockTips()
    local tipData = { h = 443, font_size = 26, des = LanUtil.getValue(126219), posY = 44,
        btnType = 1, owner = self, sureFun = self.sendUnlock };
    Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipData);
end

--英雄解锁
function Lua_HeroReshapeItem:sendUnlock()
    Lua_ProxyManager.getProxy("Lua_HeroProxy"):sHeroLock(self.unique_id, 0);
    if not self.hvo.bcore then
    	OperateAlert.showLangValue(126220);
    end
    self:onSelectItem();
end

--同调器tips
function Lua_HeroReshapeItem:showRemoveResonanceTips()
    local tipData = {
        h = 443, font_size = 26, des = LanUtil.getValue(126919), posY = 44,
        btnType = 1, owner = self, sureFun = self.sendDemount
    };
    Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipData);
end

--从同调器中卸下
function Lua_HeroReshapeItem:sendDemount()
    local grid_id = DataCenter.lifeTreeData:getGridIdByUid(self.unique_id);
    if grid_id == 0 then
        return;
    end
    Lua_ProxyManager.getProxy("Lua_LifeTreeProxy"):sDemountHero(grid_id);
end

--英雄下阵
function Lua_HeroReshapeItem:showHeroLineupTips()
    local tipData = { h = 443, font_size = 26, des = LanUtil.formateStr(126221, self.hvo.upLineupName), posY = 44,
        btnType = 1, owner = self, sureFun = self.onHeroLineup };
    Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipData);
end

--英雄下阵
function Lua_HeroReshapeItem:onHeroLineup()
    local bDownLineup;
    local showName;
    bDownLineup, showName = DataCenter.heroAssemblyData:checkLineupNumState(self.unique_id);
    if bDownLineup then--是否可以下阵
        OperateAlert.showLangValue(126222);
        DataCenter.heroAssemblyData.removeLineupStateDic[self.unique_id] = 1;
    else
        OperateAlert.show(LanUtil.formateStr(126223, showName));
        return
    end
    
    if self.hvo.lock_state == true then--上锁tips
        self:showHeroUnlockTips();
        return;
    end

    self:onSelectItem();
end

--是否核心
function Lua_HeroReshapeItem:onSelectItem()
	if self.hvo ~= nil and self.hvo.bcore then
		local tipsData = { des = LanUtil.getValue(126439), btnType = 1, owner = self, sureFun = self.onSureBtnClick };
		Lua_WindowUtil.openWin("Lua_TipsWindow", nil, tipsData);
		return;
	end
	self:onSureBtnClick();
end

function Lua_HeroReshapeItem:onSureBtnClick()
	DataCenter.heroAssemblyUtil.reshapeSelectHeroUid = self.unique_id;
	Lua_MsgUtil.callFunc("SELECT_HEROASSEMBLY_STAR", self.hvo);
end

function Lua_HeroReshapeItem:updateSelectShow()
	self.bSelect = self.unique_id == DataCenter.heroAssemblyUtil.reshapeSelectHeroUid;
    if self.bSelect then
        self.heroItem:setDrawMask(true);
        self.heroItem:setMask(false);
        self.heroItem:setLock(false);
    else
        self.heroItem:setDrawMask(false);
        local list = DataCenter.heroAssemblyData.removeLineupStateDic;
        if self.hvo.lock_state == true or self.hvo.is_resonance or (self.hvo.isUpLineup == true and list[self.unique_id] ~= 1) then
            self.heroItem:setLock(true);
            self.heroItem:setMask(true);
        else
            self.heroItem:setMask(false);
            self.heroItem:setLock(false);
        end
    end
end