Lua_HeroReshapeWindow = class("Lua_HeroReshapeWindow", Lua_Window);
function Lua_HeroReshapeWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_HeroReshapeWindow";
	self.skinName = "HeroReshapeWindow_skin";
	self.showBlackMask = true;
end

function Lua_HeroReshapeWindow:buildShowItem()
	self:superCall("buildShowItem");
	self.heroIocn = Lua_HeroItemIcon.new(self.content);
	self.heroIocn:setLocation(0, 150, 0);

	self.remianTimes = DataCenter.heroUtil.rollback_num - DataCenter.heroAssemblyData.rollbackTime;

	self.tipIcon:addClickFuntion(self, self.onTipTconClick);
	self.btnReshape:addClickFuntion(self, self.onReshapeClick);
end

function Lua_HeroReshapeWindow:dispose()
	if self.heroIocn ~= nil then
		self.heroIocn:dispose();
		self.heroIocn = nil;
	end
	if self.costIconItem ~= nil then
		self.costIconItem:dispose()
		self.costIconItem = nil;
	end
	self:superCall("dispose");
end

function Lua_HeroReshapeWindow:showWin(param)
	self:superCall("showWin", param);

	local heroVo = Lua_HeroVo.new(param.id);
	heroVo.star = self.showData.star;
	if param.level > heroVo.heroUpgradeVo.limit_level then
		heroVo.level = heroVo.heroUpgradeVo.limit_level;
	else
		heroVo.level = param.level;
	end
	self.heroIocn:setData(heroVo);

	self.remainTime = DataCenter.heroUtil.rollback_num - DataCenter.heroAssemblyData.rollbackTime;
	if self.remainTime < 0 then
		self.remainTime = 0;
	end
	local rate = DataCenter.heroUtil.rebuild_ratio * 100;
	self.tipTxt.text = LanUtil.formateStr(126425, tostring(heroVo.colorName), tostring(rate));

	if self.remianTimes > 0 then
		self.promptTxt:setEnable(true);
		self.promptTxt.text = LanUtil.formateStr(126432, tostring(self.remianTimes));
		if self.costIconItem ~= nil then
			self.costIconItem:setEnable(false);
		end
	else
		self.promptTxt:setEnable(false);
		local cfgData = DataCenter.heroUtil:rebuildConfig(param.star);
		if cfgData ~= nil and self.costIconItem == nil then
			self.costIconItem = Lua_ConsumeIconItem.new(self.content);
			self.costIconItem:setLocation(0, -120, 0);
			self.costIconItem:setStyle(Lua_MyUISettings.defaultFontName, 22, "565656");

			self.costInfo = cfgData.resource;
			self.costIconItem:setData(self.costInfo);
		end
	end
end

function Lua_HeroReshapeWindow:onTipTconClick(go)
	-- local str = "";
	-- local info = self.showData.heroUpStarVo;
	-- local list = info.rebuild_material;
	-- local len = #list;
	-- local vo;
	-- for i = 1, len do
	-- 	vo = Lua_ToolVo.new(list[i][1]);
	-- 	str = str..LanUtil.formateStr(126412, tostring(list[i][2]), vo.colorName, tostring(list[i][3]));
	-- 	if i < len then
	-- 		str = str..",";
	-- 	end
	-- end

	-- list = info.rebuild_item;
	-- if list ~= nil then
	-- 	len = #list;
	-- 	for i = 1, len do
	-- 		vo = Lua_ToolVo.new(list[i][1]);
	-- 		str = str .. LanUtil.formateStr(126413, vo.colorName, tostring(list[i][2]));
	-- 		if i < len then
	-- 			str = str .. ",";
	-- 		end
	-- 	end
	-- end

	local param = { des = LanUtil.getValue(126435), posX = 180, posY = -375 };
	Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, param);
end

function Lua_HeroReshapeWindow:onReshapeClick(go)
	if self.remianTimes > 0 or (self.costInfo ~= nil and DataCenter.packData:getItemCountById(self.costInfo[1]) >= self.costInfo[2]) then
		Lua_ProxyManager.getProxy("Lua_HeroAssemblyProxy"):sHeroReshape(self.showData.unique_id);
		self:hide();
	else
		OperateAlert.showLangValue(126415);
	end
end