-- 升星消耗道具 item
Lua_HeroFastUpStarCostItem = class("Lua_HeroFastUpStarCostItem", Lua_DisplayObject);
function Lua_HeroFastUpStarCostItem:ctor(p)
    self:superCall("ctor", p, "HeroFastUpStarCostItem_skin");
end

function Lua_HeroFastUpStarCostItem:buildShowItem()
	self:superCall("buildShowItem");
    self.mask_bg:setEnable(false);
    self.item_bg:addClickFuntion(self, self.onHeroIconClick);
    self.add_icon:addClickFuntion(self, self.onHeroIconClick);
end

function Lua_HeroFastUpStarCostItem:setData(data)
    self.upStarCostVo = data;
    local hvo = data.heroVo;
    self.index = self.upStarCostVo.costMaterialsIndex;
    if hvo.id == 0 then
        self.item_img:setAltas("common_altas_1", "ui_common_hero_icon"..hvo.star);
    else
        self.item_img:setAltas(hvo.atlas, hvo.sprite);
    end
    self.item_bg:setAltas("common_altas_1", "xui_common_itembg_"..hvo.color);
    self.item_camp:setAltas("common_altas_3",data.heroVo.campSprite);
    self:showStarsItem(hvo.star);
    self:setSelectNum();
end

function Lua_HeroFastUpStarCostItem:setSelectNum()
	local selectNum = DataCenter.heroUpStarData:getSelectHeroNumByIndex(self.index);
    local needNum = self.upStarCostVo.needNum;
    self.add_icon:setEnable(selectNum ~= needNum);
    
    self.item_bg:setGray(selectNum ~= needNum);
    self.item_img:setGray(selectNum ~= needNum);

    if selectNum == needNum then
        selectNum = Lua_ColorDefine.getColorStr("09DC2D", selectNum);
    else
        selectNum = Lua_ColorDefine.getColorStr("EF0606", selectNum);
    end
	self.show_value.text = selectNum.."/"..self.upStarCostVo.needNum;
end

function Lua_HeroFastUpStarCostItem:showStarsItem(star) -- 显示星
    if star ~= nil and star <= 10 then
        if self.starInfo == nil then
            self.starInfo = Array();
        end
        local showStar = DataCenter.heroUtil:getShowStar(star);
        local len = self.starInfo:getSize();
        local spr = DataCenter.heroUtil:getStarSprite(star, 3);
        local starWidth = 12;
        local num = len;
        if len < showStar then
            num = showStar;
        end
        for i = 1, num do
            local item = self.starInfo[i];
            if item == nil then
                item = UICreate.createUIAtlasImage(self.content, "common_altas_1", "ui_common_label_11", 0, 0, 26, 27);
                item.siblingIndex = 10 + i;
                self.starInfo:add(item);
            else
                item:setEnable(i <= showStar);
            end
            item:setLocation(-1 * starWidth * showStar / 2 + starWidth * (i-1) + starWidth / 2, -50, 0);
            item:setAltas("common_altas_1", spr);
        end
    else
        if self.starInfo ~= nil then
            local len = self.starInfo:getSize();
            for i = 1, len do
                self.starInfo[i]:setEnable(false);
            end
        end
    end
end

--红点
function Lua_HeroFastUpStarCostItem:showRedDot(bool)
    if val == true then
        if self.redDotIcon == nil then
            self.redDotIcon = Lua_RedPointIcon.new(self.content);
            self.redDotIcon:setLocation(45, 45, 0);
            self.redDotIcon:createRedPointImg(nil);
        end
        self.redDotIcon:updateRedPointShow(true);
    else
        if self.redDotIcon ~= nil then
            self.redDotIcon:updateRedPointShow(false);
        end
    end
end

function Lua_HeroFastUpStarCostItem:onHeroIconClick()
	Lua_WindowUtil.openWin("Lua_HeroSelectCostWindow", Lua_WinParam.ACTION_OPEN, self.upStarCostVo);
end

function Lua_HeroFastUpStarCostItem:dispose()
	if self.starInfo ~= nil then
        self.starInfo:dispose();
        self.starInfo:clear();
        self.starInfo = nil;
    end
	self.upStarCostVo = nil;
	self:superCall("dispose");
end