--英雄殿 快捷升星panel
checkRequire("Lua_HeroFastUpStarItem");
checkRequire("Lua_HeroFastUpStarCostItem");
Lua_HeroFastUpStarPanel = class("Lua_HeroFastUpStarPanel", Lua_HeroAssemblyPanel);
function Lua_HeroFastUpStarPanel:ctor(p)
	self:superCall("ctor", p, "HeroFastUpStarPanel_skin");
end

function Lua_HeroFastUpStarPanel:buildShowItem()
	self:superCall("buildShowItem");
	self:addLuaEvent("UPDATA_HERO_ASSEMBLY_INFO", self, self.updateUpStarSucceedInfo);--升星成功
	self:addLuaEvent("UPDATA_SELECT_COST_HERO_NUM", self, self.updateSelectCostHeroNum);--选择材料后更新数量
	self:addLuaEvent("UPDATE_INTELLIGENT_STATE", self, self.onFastUpStarEnd);
	self:addLuaEvent("UPDATE_COMP_SELECT", self, self.updateCampSelected);

	self.talkTxt:setLangValue(126414);
	self.bg_1:setEnable(false);
	self.showHeroObj:SetActive(true);
	self.btnTujian:setEnable(false);
	self.btnUpStar:setEnable(false);

	self.showTipObj:SetActive(false);
	
	self.itemList = Lua_DragList.new(self.content, 640, 280, Lua_AxisDefine.Vertical);
	self.itemList:setRectAnchor(7);
	self.itemList:setLocation(0, 453, 0);
	self.itemList:setListCell(Lua_HeroFastUpStarItem, 112, 140, 5);
	self.itemList:setCellSpacing(20, 0);
	self.itemList.tweenId = 2003;
    self.itemList.delayTween = true;

    self.campSiftPanel = Lua_CampSiftPanel.new(self.content);
    self.campSiftPanel:setRectAnchor(7);
    self.campSiftPanel:setLocation(-32, 150, 0);
    self.campSiftPanel:setSiftItem(82);
    self.campSiftPanel:setArrayData(DataCenter.heroUtil.siftAllInfo);
    self.campSiftPanel:setCallBack(self, self.onCampSelected);
    
	self:updateSiftCampRedDot();
	self.btnUpStar:addClickFuntion(self, self.onUpStarClick);
	self.btnAllUpStar:addClickFuntion(self, self.onAllUpStarClick);
	self.btnTujian:addClickFuntion(self, self.onTuijianClick);
	self.btnHelp:addClickFuntion(self, self.onHelpClick);
end

function Lua_HeroFastUpStarPanel:dispose()
	if self.itemList ~= nil then
		self.itemList:dispose();
		self.itemList = nil;
	end
	if self.campSiftPanel ~= nil then
		self.campSiftPanel:dispose();
		self.campSiftPanel = nil;
	end
	if self.campArr ~= nil then
		self.campArr:dispose();
		self.campArr:clear();
		self.campArr = nil;
	end
	if self.costHeroArr ~= nil then
		self.costHeroArr:dispose();
		self.costHeroArr:clear();
		self.costHeroArr = nil;
	end
	if self.showModelEff ~= nil then
        self.showModelEff:dispose();
        self.showModelEff = nil;
    end
    if self.maskBg ~= nil then
    	self.maskBg:dispose();
		self.maskBg = nil;
	end
    DataCenter.heroUpStarData.bUpStarHeroVo = nil;
    Lua_CommonUtil.removeTimer(self, self.onOpenUpStarSucceedWindow);
	self.data = nil;
	DataCenter.heroAssemblyData:dispose();
	self:superCall("dispose");
end

function Lua_HeroFastUpStarPanel:updateShowInfo()
	self.campSiftPanel:setSelected(Lua_HeroUtil.All_TYPE, true);
end

--更新阵容红点
function Lua_HeroFastUpStarPanel:updateSiftCampRedDot()
	local arr = self.campSiftPanel.campArr;
	if arr ~= nil then
		for i=1,arr:getSize() do
			arr[i]:showRedPoint(DataCenter.heroAssemblyUtil:getUpStarCampRedDot(arr[i].data))
		end
	end
end

function Lua_HeroFastUpStarPanel:onCampSelected(campType, isUpdate)
	if DataCenter.heroUpStarData.bUpStarHeroVo == false then
		return
	end

	if self.selectedCampType == campType and isUpdate ~= true then
		return;
	end
	self.selectedCampType = campType;

	local arr = DataCenter.heroAssemblyUtil:getUpStarInfoByCampType(campType);
	self.itemList:setArrayData(arr);
	self.itemList:moveToIndex(1, true);
	self.itemList:setSelectClick(1);
end

function Lua_HeroFastUpStarPanel:updateHeroSelect(data)
	if self.data == data then
		return;
	end
	self.data = data;

	DataCenter.heroUpStarData:initUpStarData(nil);
	if data == nil then
		self.isFristEnter = true;
		self.bg_1:setEnable(false);
		self.showHeroObj:SetActive(false);
		self.btnTujian:setEnable(false);
		self.btnUpStar:setEnable(false);

		self:showStar(0);
		self:showCostHeroItem(nil);
	else
		self.bg_1:setEnable(true);
		self.btnTujian:setEnable(true);
		self.showHeroObj:SetActive(true);
		self.btnUpStar:setEnable(true);

		self.typeIcon:setAltas("common_altas_3", tostring(data.campSprite));
		self.nameText.text = data.name;
		self.levelTxt.text = LanUtil.formateStr(126428, data.level);
		self:showStar(data.show_star);
		self:showCostHeroItem(data.heroUpStarVo);
	end
end

-- 升星英雄消耗
function Lua_HeroFastUpStarPanel:showCostHeroItem(heroUpStarVo)
	if heroUpStarVo ~= nil then
		local arr = heroUpStarVo.speedyCostHeroInfo;
		if self.costHeroArr == nil then
			self.costHeroArr = Array();
		end
		local len = self.costHeroArr:getSize();
		for i = 1, len do
			self.costHeroArr[i]:setEnable(false);
		end
		for i = 1, arr:getSize() do
			local item = nil;
			if self.costHeroArr[i] ~= nil then
				item = self.costHeroArr[i];
			else
				item = Lua_HeroFastUpStarCostItem.new(self.content);
				self.costHeroArr:add(item);
			end

            --需要自动选择材料的需要筛选一次数据
            if arr[i].isFastAutoSelect then
            	arr[i]:initialCostInfo();
            end
            item:setData(arr[i]);
            item:setRectAnchor(7);
            item:setLocation(-280 + (i - 1) * 130, 685, 0);
            item:setEnable(true);
        end
    else
    	if self.costHeroArr ~= nil then
    		local len = self.costHeroArr:getSize();
    		for i = 1, len do
    			self.costHeroArr[i]:setEnable(false);
    		end
    	end
    end
end

--更新材料选择显示
function Lua_HeroFastUpStarPanel:updateSelectCostHeroNum(costMaterialsIndex)
	if self.costHeroArr[costMaterialsIndex] ~= nil then
		self.costHeroArr[costMaterialsIndex]:setSelectNum();
	end
end

function Lua_HeroFastUpStarPanel:onUpStarClick()
	if DataCenter.heroAssemblyData.isCurHeroCanUpStar then
		local list = {};
		list[1] = {};
		for k, v in pairs(DataCenter.heroUpStarData.selectCostIndexInfo[1]) do
			list[1].unique_id = k;
		end
		list[1].Info =  DataCenter.heroUpStarData.selectCostIndexInfo;
		DataCenter.heroUpStarData.bUpStarHeroVo = false;
		Lua_ProxyManager.getProxy("Lua_HeroAssemblyProxy"):sHeroFastUpStar(list, false);
	else
		OperateAlert.showLangValue(126400);
	end
end

function Lua_HeroFastUpStarPanel:updateUpStarSucceedInfo(msg)
    if msg == nil then
        return
    end
    
    local tab = DataCenter.packData:getRewardDic(msg.item_list);
    self.itemArr = DataCenter.packData:getRewardList(tab);
    self:showMask(true);
    self:showUpStarEff();
    Lua_CommonUtil.delayCall(2, self, self.onOpenUpStarSucceedWindow);
end

function Lua_HeroFastUpStarPanel:onOpenUpStarSucceedWindow()
    if self.itemArr == nil then
        return
    end
    Lua_MsgUtil.callFunc("UP_START_HERO_MODEL", DataCenter.heroUpStarData.bUpStarHeroVo);
    DataCenter.heroUpStarData.bUpStarHeroVo = nil;
	Lua_WindowUtil.openWin("Lua_ObtainItemTipsWindow", Lua_WinParam.ACTION_OPEN, self.itemArr);
	self.itemArr = nil;
	self:showMask(false);
	self:onCampSelected(self.selectedCampType, true);
end

function Lua_HeroFastUpStarPanel:showUpStarEff()
    local modelUrl = "/effects/scsEffects/yingxiong_shengxing_01";
    local url = UrlManager.fixFileSuffix(modelUrl);
    self.showModelEff = ModelEffComponent(Lua_HeroAssemblyUtil.sceneId, 0);
    self.showModelEff:setFullUrl(url, "yingxiong_shengxing_01", "yingxiong_shengxing_01", nil);
end

--展示遮罩
function Lua_HeroFastUpStarPanel:showMask(bool)
	if bool then
		if self.maskBg == nil then
			self.maskBg = UICreate.createUIAtlasImage(self.content, "common_altas_1", "black_mask", 0, 430, 720, 645);
			self.maskBg.alpha = 0.01;
			self.maskBg.anchor = Lua_WindowUtil.getAnchor(7);
			self.maskBg:addClickFuntion(self, self.onMaskClick);
		end
		self.maskBg:setEnable(true)
	else
		if self.maskBg ~= nil then
			self.maskBg:setEnable(false);
		end
	end
end

function Lua_HeroFastUpStarPanel:onMaskClick()

end

function Lua_HeroFastUpStarPanel:onAllUpStarClick()
	if DataCenter.heroAssemblyUtil.isCanOneKeyUpStar then
		Lua_WindowUtil.openWin("Lua_HeroFastUpOnekeyWindow", Lua_WinParam.ACTION_OPEN)
	else
		OperateAlert.showLangValue(126401);
	end
end

function Lua_HeroFastUpStarPanel:onTuijianClick()
	if self.data == nil then
		return;
	end
	DataCenter.heroAtlasData:onOpenAtlasWindow(self.data.id);
end

function Lua_HeroFastUpStarPanel:onHelpClick()
	local tipsData = { des = LanUtil.getValue(126419), posX = 215, posY = -175 };
	Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
end

function Lua_HeroFastUpStarPanel:onFastUpStarEnd()
	local data = self.data;
	self.data = nil;
	self:updateHeroSelect(data);
	self:updateCampSelected();
	self:updateSiftCampRedDot();
	OperateAlert.showLangValue(126411);
end

function Lua_HeroFastUpStarPanel:updateCampSelected()
	self:onCampSelected(self.selectedCampType, true);
end